#ifndef HW_IMPL_ZYBO
#define HW_IMPL_ZYBO

#include "hw_iface.h"

#include <sleep.h>
#include <stdlib.h>
#include <xtmrctr.h>
#include <xgpiops.h>
#include "xiicps.h"
#include "xparameters.h"
#include "xgpiops.h"
#include "xil_types.h"
#include "xscugic.h"
#include "xtime_l.h"
#include "xuartps.h"
#include "queue.h"
#include "platform.h"
#include "sleep.h"

int zybo_uart_reset(struct UARTDriver *self);
int zybo_uart_write(struct UARTDriver *self, unsigned char *data, unsigned int length);
int zybo_uart_read(struct UARTDriver *self, unsigned char *buff, unsigned int length);

int zybo_pwm_output_reset(struct PWMOutputDriver *self);
int zybo_pwm_output_write(struct PWMOutputDriver *self, unsigned int channel, unsigned long pulse_width_us);

int zybo_pwm_input_reset(struct PWMInputDriver *self);
int zybo_pwm_input_read(struct PWMInputDriver *self, unsigned int channel, unsigned long *pulse_width_us);

int zybo_i2c_reset(struct I2CDriver *self);
int zybo_i2c_write(struct I2CDriver *self,
                   unsigned short device_addr,
                   unsigned char *data,
                   unsigned int length);
int zybo_i2c_read(struct I2CDriver *self,
                  unsigned short device_addr,
                  unsigned char *buff,
                  unsigned int length);

int zybo_global_timer_reset(struct TimerDriver *self);
int zybo_global_timer_restart(struct TimerDriver *self);
int zybo_global_timer_read(struct TimerDriver *self, unsigned long *us);

int zybo_axi_timer_reset(struct TimerDriver *self);
int zybo_axi_timer_restart(struct TimerDriver *self);
int zybo_axi_timer_read(struct TimerDriver *self, unsigned long *us);

int zybo_mio7_led_reset(struct LEDDriver *self);
int zybo_mio7_led_turn_on(struct LEDDriver *self);
int zybo_mio7_led_turn_off(struct LEDDriver *self);

int zybo_system_reset(struct SystemDriver *self);
int zybo_system_sleep(struct SystemDriver *self, unsigned long us);

struct UARTDriver create_zybo_uart();
struct PWMOutputDriver create_zybo_pwm_outputs();
struct PWMInputDriver create_zybo_pwm_inputs();
struct I2CDriver create_zybo_i2c();
struct TimerDriver create_zybo_global_timer();
struct TimerDriver create_zybo_axi_timer();
struct LEDDriver create_zybo_mio7_led();
struct SystemDriver create_zybo_system();

int test_zybo_i2c();
int test_zybo_mio7_led_and_system();

#endif
