#include "hw_impl_zybo.h"
#include "type_def.h"
#include "iic_utils.h"
#include <stdio.h>

/**
 * Use the LEDDriver and SystemDriver to create a basic "blink" program,
 * using the mio7 LED on the Zybo board.
 *
 * Instructions:
 * 1) Use the USB cable and plug Zybo board into computer.
 * 2) Run.
 * 3) Observe MIO7 LED on board blinking at 1 second intervals.
 */
int test_zybo_mio7_led_and_system() {
  struct LEDDriver mio7 = create_zybo_mio7_led();
  struct SystemDriver sys = create_zybo_system();
  mio7.reset(&mio7);
  sys.reset(&sys);

  while (1) {
    mio7.turn_on(&mio7);
    sys.sleep(&sys, 1000000);
    mio7.turn_off(&mio7);
    sys.sleep(&sys, 1000000);
  }

  return 0;
}

int test_zybo_i2c() {
  struct I2CDriver i2c = create_zybo_i2c();
  struct SystemDriver sys = create_zybo_system();
  i2c.reset(&i2c);
  sys.reset(&sys);

  lidar_t lidar = { };
  iic_set_globals(&i2c, &sys);
  if (iic0_lidarlite_init()) return 0;
  short x;
  while (1) {
    iic0_lidarlite_read_distance(&lidar);
    x = lidar.distance_cm;
  }
  return 0;
}


